## kfreebsd-10 10.1~svn274115

=== sys/Makefile ===
# $FreeBSD$

.include <bsd.own.mk>

# The boot loader
.if ${MK_BOOT} != "no"
SUBDIR=	boot
.endif

# Directories to include in cscope name file and TAGS.
CSCOPEDIRS=	boot bsm cam cddl compat conf contrib crypto ddb dev fs gdb \
		geom gnu isa kern libkern modules net net80211 netatalk \
		netgraph netinet netinet6 netipsec netipx netnatm \
		netsmb nfs nfsclient nfsserver nlm ofed opencrypto \
		pci rpc security sys ufs vm xdr xen ${CSCOPE_ARCHDIR}
.if !defined(CSCOPE_ARCHDIR)
.if defined(ALL_ARCH)
CSCOPE_ARCHDIR = amd64 arm i386 ia64 mips pc98 powerpc sparc64 x86
.else
CSCOPE_ARCHDIR = ${MACHINE} 
.if ${MACHINE} != ${MACHINE_CPUARCH}
CSCOPE_ARCHDIR += ${MACHINE_CPUARCH}
.endif
.if ${MACHINE_CPUARCH} == "i386" || ${MACHINE_CPUARCH} == "amd64"
CSCOPE_ARCHDIR += x86
.endif
.endif
.endif

# Loadable kernel modules

.if defined(MODULES_WITH_WORLD)
SUBDIR+=modules
.endif

HTAGSFLAGS+= -at `awk -F= '/^RELEASE *=/{release=$2}; END {print "FreeBSD", release, "kernel"}' < conf/newvers.sh`

# You need the devel/cscope port for this.
cscope: cscope.out
cscope.out: ${.CURDIR}/cscope.files
	cd ${.CURDIR}; cscope -k -buq -p4 -v

${.CURDIR}/cscope.files: .PHONY
	cd ${.CURDIR}; \
		find ${CSCOPEDIRS} -name "*.[chSsly]" -a -type f > ${.TARGET}

cscope-clean:
	rm -f cscope.files cscope.out cscope.in.out cscope.po.out

# You need the devel/global and one of editor/emacs* ports for that.
TAGS ${.CURDIR}/TAGS: ${.CURDIR}/cscope.files
	rm -f ${.CURDIR}/TAGS
	cd ${.CURDIR}; xargs etags -a < ${.CURDIR}/cscope.files

# You need the textproc/glimpse ports for this.
glimpse:
.if !exists(${.CURDIR}/.glimpse_exclude)
	echo .svn > ${.CURDIR}/.glimpse_exclude
	echo /compile/ >> ${.CURDIR}/.glimpse_exclude
.endif
	cd ${.CURDIR}; glimpseindex -H . -B -f -o .

glimpse-clean:
	cd ${.CURDIR}; rm -f .glimpse_*

.include <bsd.subdir.mk>

=== sys/amd64/Makefile ===
# $FreeBSD$
#	@(#)Makefile	8.1 (Berkeley) 6/11/93

# Makefile for amd64 links, tags file

# SYS is normally set in Make.tags.inc
SYS=/sys

TAGDIR=	amd64

.include "../kern/Make.tags.inc"

all:
	@echo "make links or tags only"

# Directories in which to place amd64 tags links
DAMD64=	acpica amd64 ia32 include isa linux32 pci

links::
	-for i in ${COMMDIR1}; do \
	    (cd $$i && { rm -f tags; ln -s ../${TAGDIR}/tags tags; }) done
	-for i in ${COMMDIR2}; do \
	    (cd $$i && { rm -f tags; ln -s ../../${TAGDIR}/tags tags; }) done
	-for i in ${DAMD64}; do \
	    (cd $$i && { rm -f tags; ln -s ../tags tags; }) done

SAMD64=	${SYS}/amd64/acpica/*.[ch] \
	${SYS}/amd64/amd64/*.[ch] ${SYS}/amd64/ia32/*.[ch] \
	${SYS}/amd64/include/*.[ch] ${SYS}/amd64/isa/*.[ch] \
	${SYS}/amd64/linux32/*.[ch] ${SYS}/amd64/pci/*.[ch]
AAMD64=	${SYS}/amd64/amd64/*.S

tags::
	-ctags -wdt ${COMM} ${SAMD64}
	egrep "^ENTRY(.*)|^ALTENTRY(.*)" ${AAMD64} | \
	    sed "s;\([^:]*\):\([^(]*\)(\([^, )]*\)\(.*\);\3 \1 /^\2(\3\4$$/;" \
		>> tags
	sort -o tags tags
	chmod 444 tags

=== sys/boot/Makefile ===
# $FreeBSD$

.include <bsd.own.mk>
.include <bsd.arch.inc.mk>

.if ${MK_FORTH} != "no"
# Build the add-in FORTH interpreter.
SUBDIR+=		ficl
.endif

# Pick the machine-dependent subdir based on the target architecture.
ADIR=			${MACHINE:S/powerpc64/powerpc/}
.if exists(${.CURDIR}/${ADIR}/.)
SUBDIR+=		${ADIR}
.endif
.if ${MACHINE} == "amd64"
SUBDIR+=		i386
.endif

.include <bsd.subdir.mk>

=== sys/i386/Makefile ===
# $FreeBSD$
#	@(#)Makefile	8.1 (Berkeley) 6/11/93

# Makefile for i386 links, tags file

# SYS is normally set in Make.tags.inc
SYS=/sys

TAGDIR=	i386

.include "../kern/Make.tags.inc"

all:
	@echo "make links or tags only"

# Directories in which to place i386 tags links
DI386=	apm i386 ibcs2 include isa linux

links::
	-for i in ${COMMDIR1}; do \
	    (cd $$i && { rm -f tags; ln -s ../${TAGDIR}/tags tags; }) done
	-for i in ${COMMDIR2}; do \
	    (cd $$i && { rm -f tags; ln -s ../../${TAGDIR}/tags tags; }) done
	-for i in ${DI386}; do \
	    (cd $$i && { rm -f tags; ln -s ../tags tags; }) done

SI386=	${SYS}/i386/acpica/*.[ch] ${SYS}/i386/bios/*.[ch] \
	${SYS}/i386/i386/*.[ch] ${SYS}/i386/ibcs2/*.[ch] \
	${SYS}/i386/include/*.[ch] ${SYS}/i386/isa/*.[ch] \
	${SYS}/i386/linux/*.[ch] ${SYS}/i386/pci/*.[ch]
AI386=	${SYS}/i386/i386/*.s

tags::
	-ctags -wdt ${COMM} ${SI386}
	egrep "^ENTRY(.*)|^ALTENTRY(.*)" ${AI386} | \
	    sed "s;\([^:]*\):\([^(]*\)(\([^, )]*\)\(.*\);\3 \1 /^\2(\3\4$$/;" \
		>> tags
	sort -o tags tags
	chmod 444 tags

=== sys/modules/Makefile ===
# $FreeBSD$

.include <bsd.own.mk>

SUBDIR_PARALLEL=

# Modules that include binary-only blobs of microcode should be selectable by
# MK_SOURCELESS_UCODE option (see below).

SUBDIR=	\
	${_3dfx} \
	${_3dfx_linux} \
	${_aac} \
	${_aacraid} \
	accf_data \
	accf_dns \
	accf_http \
	acl_nfs4 \
	acl_posix1e \
	${_acpi} \
	ae \
	${_aesni} \
	age \
	${_agp} \
	aha \
	${_ahb} \
	ahci \
	${_aic} \
	aic7xxx \
	aio \
	alc \
	ale \
	alq \
	${_amdsbwd} \
	${_amdtemp} \
	amr \
	${_an} \
	${_aout} \
	${_apm} \
	${_arcmsr} \
	${_arcnet} \
	${_asmc} \
	${_asr} \
	ata \
	ath \
	ath_pci \
	autofs \
	${_auxio} \
	${_bce} \
	bfe \
	bge \
	${_bxe} \
	${_bios} \
	${_bktr} \
	${_bm} \
	bridgestp \
	bwi \
	bwn \
	cam \
	${_canbepm} \
	${_canbus} \
	${_cardbus} \
	${_carp} \
	cas \
	${_cbb} \
	cc \
	cd9660 \
	cd9660_iconv \
	${_ce} \
	${_cfi} \
	${_ciss} \
	${_cm} \
	${_cmx} \
	${_coff} \
	${_coretemp} \
	${_cp} \
	${_cpsw} \
	${_cpuctl} \
	${_cpufreq} \
	${_crypto} \
	${_cryptodev} \
	${_cs} \
	${_ct} \
	${_ctau} \
	ctl \
	${_cxgb} \
	${_cxgbe} \
	${_cyclic} \
	dc \
	dcons \
	dcons_crom \
	de \
	${_dpms} \
	${_dpt} \
	${_drm} \
	${_drm2} \
	${_dtrace} \
	dummynet \
	${_ed} \
	${_elink} \
	${_em} \
	en \
	${_ep} \
	${_epic} \
	esp \
	${_et} \
	${_ex} \
	${_exca} \
	${_ext2fs} \
	${_fatm} \
	fdc \
	fdescfs \
	${_fe} \
	${_filemon} \
	firewire \
	firmware \
	fuse \
	${_fxp} \
	gem \
	geom \
	${_glxiic} \
	${_glxsb} \
	hatm \
	hifn \
	hme \
	${_hpt27xx} \
	${_hptiop} \
	${_hptmv} \
	${_hptnr} \
	${_hptrr} \
	hwpmc \
	${_hyperv} \
	${_i2c} \
        ${_ibcore} \
	${_ibcs2} \
	${_ichwd} \
	${_ida} \
	${_ie} \
	if_bridge \
	if_disc \
	if_edsc \
	if_ef \
	if_epair \
	if_faith \
	if_gif \
	${_if_gre} \
	if_lagg \
	${_if_ndis} \
	if_stf \
	if_tap \
	if_tun \
	if_vlan \
	${_igb} \
	${_iir} \
	${_imgact_binmisc} \
	${_io} \
        ${_ipoib} \
	${_ipdivert} \
	${_ipfilter} \
	${_ipfw} \
	ipfw_nat \
	${_ipmi} \
	ip6_mroute_mod \
	ip_mroute_mod \
	${_ips} \
	${_ipw} \
	${_ipwfw} \
	${_isci} \
	iscsi \
	iscsi_initiator \
	isp \
	${_ispfw} \
	${_iwi} \
	${_iwifw} \
	${_iwn} \
	${_iwnfw} \
	${_ixgb} \
	${_ixgbe} \
	${_ixl} \
	${_ixlv} \
	jme \
	joy \
	kbdmux \
	kgssapi \
	kgssapi_krb5 \
	khelp \
	krpc \
	ksyms \
	le \
	lge \
	libalias \
	libiconv \
	libmbpool \
	libmchain \
	${_lindev} \
	${_linprocfs} \
	${_linsysfs} \
	${_linux} \
	lmc \
	lpt \
	mac_biba \
	mac_bsdextended \
	mac_ifoff \
	mac_lomac \
	mac_mls \
	mac_none \
	mac_partition \
	mac_portacl \
	mac_seeotheruids \
	mac_stub \
	mac_test \
	malo \
	mcd \
	md \
	mem \
	mfi \
	mii \
	mlx \
	${_mlx4} \
	${_mlx4ib} \
	${_mlxen} \
	${_mly} \
	mmc \
	mmcsd \
	mpr \
	mps \
	mpt \
	mqueue \
	mrsas \
	msdosfs \
	msdosfs_iconv \
	${_mse} \
	msk \
	${_mthca} \
	mvs \
	mwl \
	${_mwlfw} \
	mxge \
	my \
	${_nandfs} \
	${_nandsim} \
	${_ncp} \
	${_ncv} \
	${_ndis} \
	netfpga10g \
	${_netgraph} \
	${_nfe} \
	nfs_common \
	nfscl \
	nfsclient \
	nfscommon \
	nfsd \
	nfslock \
	nfslockd \
	nfsserver \
	nfssvc \
	nge \
	nmdm \
	${_nsp} \
	nullfs \
	${_ntb} \
	${_nvd} \
	${_nve} \
	${_nvme} \
	${_nvram} \
	${_nxge} \
	${_opensolaris} \
	oce \
	${_padlock} \
	patm \
	${_pccard} \
	${_pcfclock} \
	pcn \
	${_pf} \
	${_pflog} \
	${_pfsync} \
	plip \
	${_pmc} \
	ppbus \
	ppc \
	ppi \
	pps \
	procfs \
	pseudofs \
	${_pst} \
	pty  \
	puc \
	${_qlxge} \
	${_qlxgb} \
	${_qlxgbe} \
	ral \
	${_ralfw} \
	${_random} \
	rc4 \
	${_rdma} \
	re \
	reiserfs \
	rl \
	${_s3} \
	${_safe} \
	${_sbni} \
	scc \
	scd \
	${_scsi_low} \
	sdhci \
	sdhci_pci \
	sem \
	send \
	${_sf} \
	${_sfxge} \
	sge \
	siba_bwn \
	siftr \
	siis \
	sis \
	sk \
	${_smbfs} \
	${_sn} \
	${_snc} \
	snp \
	${_sound} \
	${_speaker} \
	${_splash} \
	${_sppp} \
	ste \
	${_stg} \
	stge \
	${_streams} \
	${_svr4} \
	${_sym} \
	${_syscons} \
	sysvipc \
	${_ti} \
	tl \
	tmpfs \
	${_toecore} \
	${_tpm} \
	trm \
	${_twa} \
	twe \
	tws \
	tx \
	${_txp} \
	uart \
	ubsec \
	udf \
	udf_iconv \
	ufs \
	unionfs \
	usb \
	utopia \
	${_vesa} \
	${_virtio} \
	vge \
	${_viawd} \
	vkbd \
	${_vmm} \
	${_vmware} \
	${_vpo} \
	vr \
	vte \
	vx \
	${_vxge} \
	wb \
	${_wbwd} \
	${_wi} \
	wlan \
	wlan_acl \
	wlan_amrr \
	wlan_ccmp \
	wlan_rssadapt \
	wlan_tkip \
	wlan_wep \
	wlan_xauth \
	${_wpi} \
	${_wpifw} \
	${_x86bios} \
	${_xe} \
	xl \
	${_zfs} \
	zlib \

.if ${MACHINE_CPUARCH} == "i386" || ${MACHINE_CPUARCH} == "amd64"
_filemon=	filemon
_imgact_binmisc=	imgact_binmisc
_vmware=	vmware
.endif

.if ${MACHINE_CPUARCH} != "powerpc" && ${MACHINE_CPUARCH} != "arm" && \
	${MACHINE_CPUARCH} != "mips"
_syscons=	syscons
_vpo=		vpo
.endif

.if ${MACHINE_CPUARCH} != "arm" && ${MACHINE_CPUARCH} != "mips"
# no BUS_SPACE_UNSPECIFIED
# No barrier instruction support (specific to this driver)
_sym=		sym
# intr_disable() is a macro, causes problems
.if ${MK_SOURCELESS_UCODE} != "no"
_cxgb=		cxgb
.endif
.endif

.if ${MK_SOURCELESS_UCODE} != "no"
_cxgbe=		cxgbe
.endif

.if ${MK_CRYPT} != "no" || defined(ALL_MODULES)
.if exists(${.CURDIR}/../opencrypto)
_crypto=	crypto
_cryptodev=	cryptodev
.endif
.if exists(${.CURDIR}/../crypto)
_random=	random
.endif
.endif

.if (${MK_INET_SUPPORT} != "no" || ${MK_INET6_SUPPORT} != "no") || \
	defined(ALL_MODULES)
_carp=	carp
_toecore=	toecore
.endif

.if ${MK_INET_SUPPORT} != "no" || defined(ALL_MODULES)
_if_gre=	if_gre
.endif

.if ${MK_IPFILTER} != "no" || defined(ALL_MODULES)
_ipfilter=	ipfilter
.endif

.if ${MK_INET_SUPPORT} != "no" || defined(ALL_MODULES)
_ipdivert=	ipdivert
_ipfw=		ipfw
.endif

.if ${MK_NAND} != "no" || defined(ALL_MODULES)
_nandfs=	nandfs
_nandsim=	nandsim
.endif

.if ${MK_NETGRAPH} != "no" || defined(ALL_MODULES)
_netgraph=	netgraph
.endif

.if (${MK_PF} != "no" && (${MK_INET_SUPPORT} != "no" || \
	${MK_INET6_SUPPORT} != "no")) || defined(ALL_MODULES)
_pf=		pf
_pflog=		pflog
.if ${MK_INET_SUPPORT} != "no"
_pfsync=	pfsync
.endif
.endif

.if ${MK_SOURCELESS_UCODE} != "no"
_bce=		bce
_fatm=		fatm
_fxp=		fxp
_ispfw=		ispfw
_mwlfw=		mwlfw
_ralfw=		ralfw
_sf=		sf
_sn=		sn
_ti=		ti
_txp=		txp
.endif

.if ${MACHINE_CPUARCH} == "i386"
# XXX some of these can move to the general case when de-i386'ed
# XXX some of these can move now, but are untested on other architectures.
_3dfx=		3dfx
_3dfx_linux=	3dfx_linux
_agp=		agp
_aic=		aic
_an=		an
_aout=		aout
_apm=		apm
_arcnet=	arcnet
_bktr=		bktr
_bxe=		bxe
_cardbus=	cardbus
_cbb=		cbb
.if ${MK_SOURCELESS_UCODE} != "no"
_ce=		ce
.endif
_coff=		coff
.if ${MK_SOURCELESS_UCODE} != "no"
_cp=		cp
.endif
_cpuctl=	cpuctl
_cpufreq=	cpufreq
_cs=		cs
.if ${MK_CDDL} != "no" || defined(ALL_MODULES)
_cyclic=	cyclic
.endif
_dpms=		dpms
_drm=		drm
_drm2=		drm2
.if ${MK_CDDL} != "no" || defined(ALL_MODULES)
_dtrace=	dtrace
.endif
_ed=		ed
_elink=		elink
_em=		em
_ep=		ep
_et=		et
_exca=		exca
_ext2fs=	ext2fs
_fe=		fe
_glxiic=	glxiic
_glxsb=		glxsb
_i2c=		i2c
.if ${MK_OFED} != "no" || defined(ALL_MODULES)
_ibcore=        ibcore
.endif
_ibcs2=		ibcs2
_ie=		ie
_if_ndis=	if_ndis
_igb=		igb
_io=		io
.if ${MK_OFED} != "no" || defined(ALL_MODULES)
_ipoib=         ipoib
.endif
_lindev=	lindev
_linprocfs=	linprocfs
_linsysfs=	linsysfs
_linux=		linux
_mse=		mse
.if ${MK_OFED} != "no" || defined(ALL_MODULES)
_mlx4=		mlx4
_mlx4ib=	mlx4ib
_mlxen=		mlxen
_mthca=		mthca
.endif
_ncv=		ncv
_ndis=		ndis
_nsp=		nsp
.if ${MK_CDDL} != "no" || defined(ALL_MODULES)
_opensolaris=	opensolaris
.endif
_pccard=	pccard
_pcfclock=	pcfclock
_pst=		pst
_rdma=		rdma
_safe=		safe
_sbni=		sbni
_scsi_low=	scsi_low
_smbfs=		smbfs
_sound=		sound
_speaker=	speaker
_splash=	splash
_sppp=		sppp
_stg=		stg
_streams=	streams
_svr4=		svr4
_vxge=  	vxge
_wbwd=		wbwd
_wi=		wi
_xe=		xe
.if ${MK_ZFS} != "no" || defined(ALL_MODULES)
_zfs=		zfs
.endif
.if ${MACHINE} == "i386"
_aac=		aac
_aacraid=	aacraid
_acpi=		acpi
.if ${MK_CRYPT} != "no" || defined(ALL_MODULES)
_aesni=		aesni
.endif
_ahb=		ahb
_amdsbwd=	amdsbwd
_amdtemp=	amdtemp
_arcmsr=	arcmsr
_asmc=		asmc
_asr=		asr
_bios=		bios
_ciss=		ciss
_cm=		cm
_cmx=		cmx
_coretemp=	coretemp
.if ${MK_SOURCELESS_UCODE} != "no"
_ctau=		ctau
.endif
_dpt=		dpt
_ex=		ex
.if ${MK_SOURCELESS_HOST} != "no"
_hpt27xx=	hpt27xx
.endif
_hptiop=	hptiop
.if ${MK_SOURCELESS_HOST} != "no"
_hptmv=		hptmv
_hptnr=		hptnr
_hptrr=		hptrr
.endif
_hyperv=	hyperv
_ichwd=		ichwd
_ida=		ida
_iir=		iir
_ipmi=		ipmi
_ips=		ips
_ipw=		ipw
.if ${MK_SOURCELESS_UCODE} != "no"
_ipwfw=		ipwfw
.endif
_isci=		isci
_iwi=		iwi
.if ${MK_SOURCELESS_UCODE} != "no"
_iwifw=		iwifw
.endif
_iwn=		iwn
.if ${MK_SOURCELESS_UCODE} != "no"
_iwnfw=		iwnfw
.endif
_ixgb=		ixgb
_ixgbe=		ixgbe
_mly=		mly
_nfe=		nfe
_nvd=		nvd
.if ${MK_SOURCELESS_HOST} != "no"
_nve=		nve
.endif
_nvme=		nvme
_nvram=		nvram
_nxge=		nxge
_tpm=		tpm
_viawd=		viawd
_wpi=		wpi
.if ${MK_SOURCELESS_UCODE} != "no"
_wpifw=		wpifw
.endif
.if ${MK_CRYPT} != "no" || defined(ALL_MODULES)
_padlock=	padlock
.endif
_s3=		s3
_twa=		twa
_vesa=		vesa
_virtio=	virtio
_x86bios=	x86bios
.elif ${MACHINE} == "pc98"
_canbepm=	canbepm
_canbus=	canbus
_ct=		ct
_pmc=		pmc
_snc=		snc
.endif
.endif

.if ${MACHINE_CPUARCH} == "amd64"
_aac=		aac
_aacraid=	aacraid
_aout=		aout
_acpi=		acpi
.if ${MK_CRYPT} != "no" || defined(ALL_MODULES)
_aesni=		aesni
.endif
_agp=		agp
_an=		an
_amdsbwd=	amdsbwd
_amdtemp=	amdtemp
_arcmsr=	arcmsr
_asmc=		asmc
_bktr=		bktr
_bxe=		bxe
_cardbus=	cardbus
_cbb=		cbb
_cmx=		cmx
_ciss=		ciss
_coretemp=	coretemp
_cpuctl=	cpuctl
_cpufreq=	cpufreq
.if ${MK_CDDL} != "no" || defined(ALL_MODULES)
_cyclic=	cyclic
.endif
_dpms=		dpms
_drm=		drm
_drm2=		drm2
.if ${MK_CDDL} != "no" || defined(ALL_MODULES)
_dtrace=	dtrace
.endif
_ed=		ed
_et=		et
_em=		em
_exca=		exca
_ext2fs=	ext2fs
.if ${MK_SOURCELESS_HOST} != "no"
_hpt27xx=	hpt27xx
.endif
_hptiop=	hptiop
.if ${MK_SOURCELESS_HOST} != "no"
_hptmv=		hptmv
_hptnr=		hptnr
_hptrr=		hptrr
.endif
_hyperv=	hyperv
_i2c=		i2c
.if ${MK_OFED} != "no" || defined(ALL_MODULES)
_ibcore=        ibcore
.endif
_ichwd=		ichwd
_ida=		ida
_if_ndis=	if_ndis
_igb=		igb
_iir=		iir
_io=		io
_ipmi=		ipmi
.if ${MK_OFED} != "no" || defined(ALL_MODULES)
_ipoib=         ipoib
.endif
_ips=		ips
_ipw=		ipw
.if ${MK_SOURCELESS_UCODE} != "no"
_ipwfw=		ipwfw
.endif
_isci=		isci
_iwi=		iwi
.if ${MK_SOURCELESS_UCODE} != "no"
_iwifw=		iwifw
.endif
_iwn=		iwn
.if ${MK_SOURCELESS_UCODE} != "no"
_iwnfw=		iwnfw
.endif
_ixgb=		ixgb
_ixgbe=		ixgbe
_ixl=		ixl
_ixlv=		ixlv
_lindev=	lindev
_linprocfs=	linprocfs
_linsysfs=	linsysfs
_linux=		linux
_mly=		mly
.if ${MK_OFED} != "no" || defined(ALL_MODULES)
_mlx4=		mlx4
_mlx4ib=	mlx4ib
_mlxen=		mlxen
_mthca=		mthca
.endif
_ndis=		ndis
_nfe=		nfe
_ntb=		ntb
_nvd=		nvd
.if ${MK_SOURCELESS_HOST} != "no"
_nve=		nve
.endif
_nvme=		nvme
_nvram=		nvram
_nxge=		nxge
.if ${MK_CDDL} != "no" || defined(ALL_MODULES)
_opensolaris=	opensolaris
.endif
.if ${MK_CRYPT} != "no" || defined(ALL_MODULES)
_padlock=	padlock
.endif
_pccard=	pccard
_qlxge=		qlxge
_qlxgb=		qlxgb
_qlxgbe=	qlxgbe
_rdma=		rdma
_s3=		s3
_safe=		safe
_scsi_low=	scsi_low
_sfxge=		sfxge
_smbfs=		smbfs
_sound=		sound
_speaker=	speaker
_splash=	splash
_sppp=		sppp
_tpm=		tpm
_twa=		twa
_vesa=		vesa
_viawd=		viawd
_virtio=	virtio
_vmm=		vmm
_vxge=  	vxge
_x86bios=	x86bios
_wbwd=		wbwd
_wi=		wi
_wpi=		wpi
.if ${MK_SOURCELESS_UCODE} != "no"
_wpifw=		wpifw
.endif
.if ${MK_ZFS} != "no" || defined(ALL_MODULES)
_zfs=		zfs
.endif
.endif

.if ${MACHINE_CPUARCH} == "arm"
_cfi=		cfi
_cpsw=		cpsw
.endif

.if ${MACHINE_CPUARCH} == "ia64"
_aac=		aac
_aacraid=	aacraid
_aic=		aic
_an=		an
_arcnet=	arcnet
_asr=		asr
_bktr=		bktr
_cardbus=	cardbus
_cbb=		cbb
_ciss=		ciss
_cm=		cm
_cmx=		cmx
_coff=		coff
_cpufreq=	cpufreq
_dpt=		dpt
_em=		em
_ep=		ep
_et=		et
_exca=		exca
_fe=		fe
_hptiop=	hptiop
_ida=		ida
_igb=		igb
_iir=		iir
_ips=		ips
_mly=		mly
_pccard=	pccard
_scsi_low=	scsi_low
_smbfs=		smbfs
_sound=		sound
_splash=	splash
_sppp=		sppp
_streams=	streams
_tpm=		tpm
_twa=		twa
_wi=		wi
_xe=		xe
.endif

.if ${MACHINE_CPUARCH} == "powerpc"
_agp=		agp
_an=		an
_bm=		bm
_cardbus=	cardbus
_cbb=		cbb
_cfi=		cfi
_cpufreq=	cpufreq
.if ${MK_CDDL} != "no" || defined(ALL_MODULES)
_cyclic=	cyclic

=== sys/amd64/linux32/Makefile ===
# Makefile for syscall tables
#
# $FreeBSD$

all:
	@echo "make sysent only"

sysent:  linux32_sysent.c linux32_syscall.h linux32_proto.h linux32_syscalls.c linux32_systrace_args.c

linux32_sysent.c linux32_syscall.h linux32_proto.h linux32_syscalls.c linux32_systrace_args.c: ../../kern/makesyscalls.sh \
		syscalls.master syscalls.conf
	-mv -f linux32_sysent.c linux32_sysent.c.bak
	-mv -f linux32_syscall.h linux32_syscall.h.bak
	-mv -f linux32_proto.h linux32_proto.h.bak
	-mv -f linux32_syscalls.c linux32_syscalls.c.bak
	-mv -f linux32_systrace_args.c linux32_systrace_args.c.bak
	sh ../../kern/makesyscalls.sh syscalls.master syscalls.conf

=== sys/arm/conf/Makefile ===
# $FreeBSD$

TARGET=arm

.include "${.CURDIR}/../../conf/makeLINT.mk"

=== sys/boot/amd64/Makefile ===
# $FreeBSD$

.include <bsd.own.mk>

SUBDIR=		efi boot1.efi

.include <bsd.subdir.mk>

=== sys/boot/arm/Makefile ===
# $FreeBSD$

SUBDIR=		uboot

.include <bsd.subdir.mk>

=== sys/boot/efi/Makefile ===
# $FreeBSD$

SUBDIR=		libefi

.include <bsd.subdir.mk>

=== sys/boot/fdt/Makefile ===
# $FreeBSD$

.PATH:		${.CURDIR}/../../contrib/libfdt/

LIB=		fdt
INTERNALLIB=

# Vendor sources of libfdt.
SRCS+=		fdt.c fdt_ro.c fdt_wip.c fdt_sw.c fdt_rw.c fdt_strerror.c

# Loader's fdt commands extension sources.
SRCS+=		fdt_loader_cmd.c

CFLAGS+=	-I${.CURDIR}/../../contrib/libfdt/ -I${.CURDIR}/../common/ \
		-I${.CURDIR}/../uboot/lib

CFLAGS+=	-ffreestanding

.if ${MACHINE_CPUARCH} == "powerpc" || ${MACHINE_CPUARCH} == "arm"
CFLAGS+=	-msoft-float
.endif

.if ${MACHINE_ARCH} == "powerpc64"
CFLAGS+=	-m32
.endif

CFLAGS+=	-Wformat -Wall

.include <bsd.lib.mk>

=== sys/boot/ficl/Makefile ===
# $FreeBSD$
#

FICLDIR?=	${.CURDIR}

.if defined(FICL32)
.PATH: ${FICLDIR}/${MACHINE_CPUARCH:S/amd64/i386/}
.else
.PATH: ${FICLDIR}/${MACHINE_CPUARCH}
.endif
BASE_SRCS=	dict.c ficl.c fileaccess.c float.c loader.c math64.c \
		prefix.c search.c stack.c tools.c vm.c words.c

SRCS=		${BASE_SRCS} sysdep.c softcore.c
CLEANFILES=	softcore.c testmain testmain.o
CFLAGS+=	-ffreestanding
.if ${MACHINE_CPUARCH} == "i386" || \
    (${MACHINE_CPUARCH} == "amd64" && defined(FICL32))
CFLAGS+=	-march=i386
CFLAGS.gcc+=	-mpreferred-stack-boundary=2
.endif
.if ${MACHINE_CPUARCH} == "i386" || ${MACHINE_CPUARCH} == "amd64"
CFLAGS+=	-mno-mmx -mno-3dnow -mno-sse -mno-sse2 -mno-sse3 -msoft-float
.endif
.if ${MACHINE_CPUARCH} == "powerpc" || ${MACHINE_CPUARCH} == "arm"
CFLAGS+=	-msoft-float
.endif
.if ${MACHINE} == "pc98"
CFLAGS+=	-Os -DPC98
.endif
.if HAVE_PNP
CFLAGS+=	-DHAVE_PNP
.endif
.ifmake testmain
CFLAGS+=	-DTESTMAIN -D_TESTMAIN
SRCS+=		testmain.c
PROG=		testmain
.include <bsd.prog.mk>
.else
LIB=		ficl
INTERNALLIB=
.include <bsd.lib.mk>
.endif

# Standard softwords
.PATH: ${FICLDIR}/softwords
SOFTWORDS=	softcore.fr jhlocal.fr marker.fr freebsd.fr ficllocal.fr \
		ifbrack.fr
# Optional OO extension softwords
#SOFTWORDS+=	oo.fr classes.fr

.if ${MACHINE_CPUARCH} == "amd64"
.if defined(FICL32)
CFLAGS+=	-m32 -I.
.else
CFLAGS+=	-fPIC
.endif
.endif

.if ${MACHINE_ARCH} == "powerpc64"
CFLAGS+=	-m32 -mcpu=powerpc -I.
.endif

.if ${MACHINE_CPUARCH} == "amd64" && defined(FICL32)
FICL_CPUARCH=	i386
.else
FICL_CPUARCH=	${MACHINE_CPUARCH}
.endif

CFLAGS+=	-I${FICLDIR} -I${FICLDIR}/${FICL_CPUARCH} \
		-I${FICLDIR}/../common

softcore.c: ${SOFTWORDS} softcore.awk
	(cd ${FICLDIR}/softwords; cat ${SOFTWORDS} \
	    | awk -f softcore.awk -v datestamp="`LC_ALL=C date`") > ${.TARGET}

.if ${MACHINE_CPUARCH} == "amd64" && defined(FICL32)
.if !exists(machine)
${SRCS:M*.c:R:S/$/.o/g}: machine

beforedepend ${OBJS}: machine
.endif

machine:
	ln -sf ${.CURDIR}/../../i386/include machine

CLEANFILES+=	machine
.endif

=== debian/changelog ===
kfreebsd-10 (10.1~svn274115-4) unstable; urgency=high

  * Pick SVN r281232 from FreeBSD 10.1-RELEASE to fix:
    - SA-15:04: integer overflow in IGMP protocol (CVE-2015-1414)
      updated patch from advisory revision 1.1 (Closes: #779195)
    - SA-15:09: Denial of Service with IPv6 Router Advertisements
      (CVE-2015-2923) (Closes: #782107)

 -- Steven Chamberlain <steven@pyro.eu.org>  Tue, 07 Apr 2015 22:13:19 +0100

kfreebsd-10 (10.1~svn274115-3) unstable; urgency=high

  * Pick SVN r279264 from FreeBSD 10.1-RELEASE to fix:
    - SA-15:04: integer overflow in IGMP protocol (CVE-2015-1414)
      (Closes: #779195)
    - EN-15:01: vt(4) crash with improper ioctl parameters
      (CVE-2014-0998) (Closes: #779194)

 -- Steven Chamberlain <steven@pyro.eu.org>  Wed, 25 Feb 2015 12:39:32 +0000

kfreebsd-10 (10.1~svn274115-2) unstable; urgency=high

  * Pick SVN r277808 from FreeBSD 10.1-RELEASE to fix:
    - SA-15:02: SCTP SCTP_SS_VALUE kernel memory corruption and
      disclosure vulnerability (CVE-2014-8612) (Closes: #776415)
    - SA-15:03: SCTP stream reset vulnerability (CVE-2014-8613)
      (Closes: #776416)
  * Build kernel images only on kfreebsd-any arches, so that any
    security or other RC-severity kernel bugs will not affect the
    official jessie release

 -- Steven Chamberlain <steven@pyro.eu.org>  Tue, 27 Jan 2015 20:02:52 +0000

kfreebsd-10 (10.1~svn274115-1) unstable; urgency=medium

  [ Steven Chamberlain ]
  * New upstream snapshot of 10.1-RC4+
    - Fix kernel stack disclosure in setlogin(2) / getlogin(2). [SA-14:25]
      (CVE-2014-8476) (Closes: #768108)
  * Replace non-DFSG-free ar9300_devid.h with a 3-clause BSD substitute
    derived from Linux ath9k driver (Closes: #767583)

  [ Christoph Egger ]
  * Upload to unstable

 -- Christoph Egger <christoph@debian.org>  Sun, 28 Dec 2014 12:41:02 +0100

kfreebsd-10 (10.1~svn273874-1) unstable; urgency=medium

  * Upload to unstable
  * New upstream snapshot of 10.1-RC4

 -- Steven Chamberlain <steven@pyro.eu.org>  Thu, 30 Oct 2014 22:27:51 +0000

kfreebsd-10 (10.1~svn273581-1) experimental; urgency=high

  * New upstream snapshot of 10.1-RC3+
    - Fix memory leak in sandboxed namei lookup. [SA-14:22]
      (CVE-2014-3711) (Closes: #766278)
  * Symlink to drm2.ko as provider of drmn.ko dependency, for *kms
    modules (Closes: #731182)
  * NEWS: advise to reboot after upgrading kernel and userland tools
    from wheezy (Closes: #765588)

 -- Steven Chamberlain <steven@pyro.eu.org>  Tue, 21 Oct 2014 22:03:15 +0100

kfreebsd-10 (10.1~svn273304-1) unstable; urgency=medium

  * New upstream snapshot of 10.1-RC3~
  * Actually apply changes to debian/control meant to happen in the
    previous upload (changes to Breaks: and Uploaders:)

 -- Steven Chamberlain <steven@pyro.eu.org>  Fri, 17 Oct 2014 00:16:43 +0000

kfreebsd-10 (10.1~svn272463-1) unstable; urgency=low

  [ Steven Chamberlain ]
  * New upstream snapshot of 10.1-RC1
  * Set a Breaks: on freebsd-net-tools (<< 10.0~) due to an ABI change
    listing or modifying network interfaces
  * Set a Breaks: on freebsd-smbfs (<< 10.0~) due to an ABI change
    mounting an SMB filesystem
  * Set a Breaks: on pf (<< 10.1~) due to an ABI change listing or
    modifying firewall rules
  * Set a Breaks: on grub-common (<< 2.02~) because GRUB 2.02 or later
    is needed to boot from a ZFS pool having the LZ4 compression
    feature enabled
  * In get-orig-source, svn export with --ignore-keywords so that
    revision tags do not fuzzy the patches
  * Add myself to Uploaders

  [ Petr Salinger ]
  * Refresh patches
    - aicasm-parallel-build-dependencies.diff
    - userland.diff
    - 001_misc.diff
    - 999_config.diff

  [ Christoph Egger ]
  * Upload to unstable

 -- Steven Chamberlain <steven@pyro.eu.org>  Sat, 20 Sep 2014 22:02:28 +0100

kfreebsd-10 (10.1~svn271306-2) experimental; urgency=medium

  * build-depend on clang-3.4 (>= 1:3.4.2-9~exp2) for #759303 fixes
  * Add myself to uploaders
  * Wrap control fields nicely

 -- Christoph Egger <christoph@debian.org>  Thu, 18 Sep 2014 17:35:14 -0700

kfreebsd-10 (10.1~svn271306-1) experimental; urgency=medium

  [ Steven Chamberlain ]
  * New upstream snapshot of 10.1-PRERELEASE
    - Improves performance of vt(4) on vga (Closes: #755739)
  * Use the new 'make firmware' target to rebuild aic7xxx firmware from
    sources, no longer done upstream but required per the DFSG
  * Drop obsolete patch
    - 003_glibc_dev_aicasm.diff
  * Refresh patches
    - userland.diff
    - 107_mount_update.diff
    - 917_disable_kgssapi.diff
    - 999_config.diff
  * Improve build reproducibility:
    - remove last remaining occurrences of the full build path from the
      output files
    - use brandelf to give kernel modules the ELF ABI number for
      FreeBSD, even when building on Linux

  [ Christoph Egger ]
  * add aicasm-parallel-build-dependencies.diff to fix parallel build of
    aic7xx firmware

 -- Christoph Egger <christoph@debian.org>  Wed, 10 Sep 2014 09:57:11 -0700

kfreebsd-10 (10.1~svn270273-2) experimental; urgency=medium

  * Remove vt_xboxfb as it's not available currently

 -- Christoph Egger <christoph@debian.org>  Tue, 26 Aug 2014 13:15:35 -0700

kfreebsd-10 (10.1~svn270273-1) experimental; urgency=low

  [ Steven Chamberlain ]
  * New upstream snapshot of STABLE-10
  * Reset abiname to 0
  * Switch to clang-3.4 on i386, amd64, arm (Closes: #754799)
  * Switch to gcc-4.9 on other architectures (Closes: #751316)
  * Delete patches merged upstream:
    - si_status_wait6.diff
    - accept_O_CLOEXEC_in_shm_open.diff
    - newcons.diff
    - SA-14_05.nfsserver.patch
    - SA-14_08.tcp.patch
    - EN-14_05.ciss.patch
    - EN-14_06.execve.patch
  * Refresh patches:
    - radeonkms_abort_nofw.diff
    - userland.diff
    - 001_misc.diff
    - 902_version.diff
    - 908_linprocfs_is_not_proc.diff
    - 915_ip6.v6only.diff
    - 917_disable_kgssapi.diff
    - 918_unix_socket_overflow.diff
    - 999_config.diff


=== debian/control ===
Source: kfreebsd-10
Section: kernel
Priority: optional
Maintainer: GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>
Uploaders:
 Aurelien Jarno <aurel32@debian.org>,
 Robert Millan <rmh@debian.org>,
 Christoph Egger <christoph@debian.org>,
 Steven Chamberlain <steven@pyro.eu.org>,
Vcs-Browser: http://anonscm.debian.org/viewvc/glibc-bsd/trunk/kfreebsd-10/
Vcs-Svn: svn://anonscm.debian.org/glibc-bsd/trunk/kfreebsd-10/
Build-Depends:
 debhelper (>= 5.0.0),
 bzip2,
 sharutils,
 flex-old | flex,
 freebsd-buildutils (>= 10.0-3~),
 freebsd-glue (>= 0.2.20~),
 byacc,
 clang-3.4 (>= 1:3.4.2-9~exp2) [any-i386 any-amd64 any-arm], gcc-4.9 [!any-i386 !any-amd64 !any-arm],
 libdb-dev,
 libbsd-dev (>= 0.3.0),
 pkg-config,
 libsbuf-dev (>= 9.0+ds1-2),
 kernel-wedge (>= 2.79) [kfreebsd-any],
Standards-Version: 3.9.2

Package: kfreebsd-source-10.1
Architecture: all
Depends: ${misc:Depends}
Recommends: freebsd-buildutils (>= 7)
Provides: kfreebsd-source-10, kfreebsd-source
Description: source code for kernel of FreeBSD 10.1 with Debian patches
 This package provides the source code for kernel of FreeBSD 10.1, base of
 a GNU/kFreeBSD system.

Package: kfreebsd-headers-10.1-0
Architecture: kfreebsd-any
Depends: ${misc:Depends}
Description: Common architecture-specific header files for kernel of FreeBSD 10.1
 This package provides the architecture-specific common kernel header files for
 kernel of FreeBSD 10.1, generally used for building out-of-tree kernel
 modules. To obtain a complete set of headers you also need to install the
 kfreebsd-headers-10.1-0-(flavour) package, matching the flavour of the
 kernel you intend the build for. To obtain such a set for the currently running
 kernel it is sufficient to run a command
 .
 apt-get install kfreebsd-headers-$(uname -r)
 .
 and it will be unpacked in /usr/src/kfreebsd-headers-10.1-0-(flavour)


Package: kfreebsd-image-10.1-0-amd64
Architecture: kfreebsd-amd64
Depends: ${misc:Depends},
 freebsd-utils (>= 8.1-5) [kfreebsd-any], kldutils (>= 7.1) [kfreebsd-any],
 devd [kfreebsd-any] | freebsd-utils (<< 8.2+ds2-9) [kfreebsd-any],
# Policy-conformant keyboard mappings (see #605777)
 kbdcontrol (>= 8.2+ds2-6) [kfreebsd-any],
Conflicts: kfreebsd-loader (<< 5.4-1.3)
Breaks:
# ZFS metadata now compressed with LZ4 by default;  requires recent GRUB
 grub-common (<< 2.02~) [kfreebsd-any],
# AT_* macros break LD_PRELOAD (see #630695)
# Missing support for RFTSIGZMB (see 007_clone_signals.diff)
 libc0.1 (<< 2.11.3-1) [kfreebsd-any],
# Require ZFS v28 userland
 zfsutils (<< 8.3~) [kfreebsd-any],
# ABI changes since kFreeBSD 9.0
 freebsd-net-tools (<< 10.0~) [kfreebsd-any],
 freebsd-smbfs (<< 10.0~) [kfreebsd-any],
 pf (<< 10.1~) [kfreebsd-any],
Provides: kfreebsd-image-10, kfreebsd-image
Recommends: 
Description: kernel of FreeBSD 10.1 image
 This package provides the binary image and pre-built loadable modules for
 the kernel of FreeBSD 10.1, base of a GNU/kFreeBSD system.
 .
 This package is compiled for a amd64-class machine.

Package: kfreebsd-image-10-amd64
Architecture: kfreebsd-amd64
Depends: kfreebsd-image-10.1-0-amd64, ${misc:Depends}
Description: kernel of FreeBSD 10 image (meta-package)
 This package depends on the latest binary image for kernel of FreeBSD 10 on
 amd64-class machines.

Package: kfreebsd-headers-10.1-0-amd64
Architecture: kfreebsd-amd64
Provides: kfreebsd-headers-10, kfreebsd-headers
Depends: kfreebsd-headers-10.1-0 (= ${binary:Version}), ${misc:Depends}
Description: header files for kernel of FreeBSD 10.1
 This package provides the header files for kernel of FreeBSD 10.1, generally
 used for building out-of-tree kernel modules. These files are going to be
 installed into /usr/src/kfreebsd-headers-10.1-0-amd64, and can be
 used for building modules that load into the kernel provided by the
 kfreebsd-image-10.1-0-amd64 package.

Package: kfreebsd-headers-10-amd64
Architecture: kfreebsd-amd64
Depends: kfreebsd-headers-10.1-0-amd64, ${misc:Depends}
Description: header files for kernel of FreeBSD 10 (meta-package)
 This package depends on the latest header files for kernel of FreeBSD 10 on
 amd64-class machines.


Package: kernel-image-10.1-0-amd64-di
Package-Type: udeb
Provides: kernel-image, ata-modules, cdrom-core-modules, core-modules, crc-modules, ext2-modules, ide-core-modules, ide-modules, input-modules, mmc-core-modules, mouse-modules, nic-pcmcia-modules, nls-core-modules, pata-modules, pcmcia-modules, pcmcia-storage-modules, rtc-modules, scsi-common-modules, serial-modules, ufs-modules, uinput-modules, usb-modules, usb-storage-modules
Architecture: kfreebsd-amd64
Kernel-Version: 10.1-0-amd64
Section: debian-installer
Priority: extra
Description: kFreeBSD binary image for the Debian installer
 This package contains the kernel of FreeBSD for the Debian installer
 boot images. It does _not_ provide a usable kernel for your full
 Debian system.

Package: nic-modules-10.1-0-amd64-di
Package-Type: udeb
Provides: nic-modules
Depends: kernel-image-10.1-0-amd64-di, nic-shared-modules-10.1-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.1-0-amd64
Section: debian-installer
Priority: standard
Description: Common NIC drivers
 This package contains common NIC drivers for the kernel.

Package: nic-wireless-modules-10.1-0-amd64-di
Package-Type: udeb
Provides: nic-wireless-modules
Depends: kernel-image-10.1-0-amd64-di, nic-shared-modules-10.1-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.1-0-amd64
Section: debian-installer
Priority: standard
Description: Wireless NIC drivers
 This package contains wireless NIC drivers for the kernel.
 Includes crypto modules only needed for wireless (WEP).

Package: nic-shared-modules-10.1-0-amd64-di
Package-Type: udeb
Provides: nic-shared-modules
Depends: kernel-image-10.1-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.1-0-amd64
Section: debian-installer
Priority: standard
Description: Shared NIC drivers
 This package contains NIC drivers needed by combinations of nic-modules,
 nic-extra-modules, nic-pcmcia-modules, and nic-wireless-modules.

Package: serial-modules-10.1-0-amd64-di
Package-Type: udeb
Provides: serial-modules
Depends: kernel-image-10.1-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.1-0-amd64
Section: debian-installer
Priority: optional
Description: Serial drivers
 This package contains serial drivers for the kernel.

Package: usb-serial-modules-10.1-0-amd64-di
Package-Type: udeb
Provides: usb-serial-modules
Depends: kernel-image-10.1-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.1-0-amd64
Section: debian-installer
Priority: optional
Description: USB serial drivers
 This package contains USB serial drivers for the kernel.

Package: ppp-modules-10.1-0-amd64-di
Package-Type: udeb
Provides: ppp-modules
Depends: kernel-image-10.1-0-amd64-di, serial-modules-10.1-0-amd64-di, zlib-modules-10.1-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.1-0-amd64
Section: debian-installer
Priority: optional
Description: PPP drivers
 This package contains PPP drivers for the kernel.

Package: cdrom-modules-10.1-0-amd64-di
Package-Type: udeb
Provides: cdrom-modules
Depends: kernel-image-10.1-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.1-0-amd64
Section: debian-installer
Priority: optional
Description: Esoteric CDROM drivers
 This package contains esoteric CDROM drivers for the kernel.

Package: scsi-core-modules-10.1-0-amd64-di
Package-Type: udeb
Provides: scsi-core-modules
Depends: kernel-image-10.1-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.1-0-amd64
Section: debian-installer
Priority: standard
Description: Core SCSI subsystem
 This package contains the core SCSI subsystem for the kernel.

Package: scsi-modules-10.1-0-amd64-di
Package-Type: udeb
Provides: scsi-modules
Depends: kernel-image-10.1-0-amd64-di, scsi-core-modules-10.1-0-amd64-di, parport-modules-10.1-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.1-0-amd64
Section: debian-installer
Priority: standard
Description: SCSI drivers
 This package contains SCSI drivers for the kernel.

Package: scsi-extra-modules-10.1-0-amd64-di
Package-Type: udeb
Provides: scsi-extra-modules
Depends: scsi-modules-10.1-0-amd64-di, scsi-core-modules-10.1-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.1-0-amd64
Section: debian-installer
Priority: standard
Description: Uncommon SCSI drivers
 This package contains uncommon SCSI drivers for the kernel.
 This includes SCSI RAID drivers, and some of the less common SCSI
 controllers.

Package: plip-modules-10.1-0-amd64-di
Package-Type: udeb
Provides: plip-modules
Depends: kernel-image-10.1-0-amd64-di, parport-modules-10.1-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.1-0-amd64
Section: debian-installer
Priority: optional
Description: PLIP drivers
 This package contains PLIP drivers for the kernel.

Package: floppy-modules-10.1-0-amd64-di
Package-Type: udeb
Provides: floppy-modules
Depends: kernel-image-10.1-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.1-0-amd64
Section: debian-installer
Priority: standard
Description: Floppy driver
 This package contains the floppy driver for the kernel.

Package: loop-modules-10.1-0-amd64-di
Package-Type: udeb
Provides: loop-modules
Depends: kernel-image-10.1-0-amd64-di, zlib-modules-10.1-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.1-0-amd64
Section: debian-installer
Priority: standard
Description: Loopback filesystem support
 This package contains loopback filesystem support for the kernel.

Package: ipv6-modules-10.1-0-amd64-di
Package-Type: udeb
Provides: ipv6-modules
Depends: kernel-image-10.1-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.1-0-amd64
Section: debian-installer
Priority: extra
Description: IPv6 driver
 This package contains the IPv6 driver for the kernel.

Package: nls-core-modules-10.1-0-amd64-di
Package-Type: udeb
Provides: nls-core-modules
Depends: kernel-image-10.1-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.1-0-amd64
Section: debian-installer
Priority: extra
Description: Core NLS support
 This package contains basic NLS support modules for the kernel.

Package: ext2-modules-10.1-0-amd64-di
Package-Type: udeb
Provides: ext2-modules
Depends: kernel-image-10.1-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.1-0-amd64
Section: debian-installer
Priority: standard
Description: EXT2 filesystem support
 This package contains the EXT2 filesystem module for the kernel.

Package: isofs-modules-10.1-0-amd64-di
Package-Type: udeb
Provides: isofs-modules
Depends: kernel-image-10.1-0-amd64-di, nls-core-modules-10.1-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.1-0-amd64
Section: debian-installer
Priority: standard
Description: ISOFS filesystem support
 This package contains the ISOFS filesystem module for the kernel.

Package: reiserfs-modules-10.1-0-amd64-di
Package-Type: udeb
Provides: reiserfs-modules
Depends: kernel-image-10.1-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.1-0-amd64
Section: debian-installer
Priority: extra
Description: Reiser filesystem support
 This package contains the Reiser filesystem module for the kernel.

Package: fat-modules-10.1-0-amd64-di
Package-Type: udeb
Provides: fat-modules
Depends: kernel-image-10.1-0-amd64-di, nls-core-modules-10.1-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.1-0-amd64
Section: debian-installer
Priority: extra
Description: FAT filesystem support
 This package contains the FAT and VFAT filesystem modules for the kernel.

Package: zfs-modules-10.1-0-amd64-di
Package-Type: udeb
Provides: zfs-modules
Depends: kernel-image-10.1-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.1-0-amd64
Section: debian-installer
Priority: extra
Description: ZFS filesystem support
 This package contains the ZFS filesystem module for the kernel.

Package: nfs-modules-10.1-0-amd64-di
Package-Type: udeb
Provides: nfs-modules
Depends: kernel-image-10.1-0-amd64-di
Architecture: kfreebsd-amd64

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

SHELL = bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_ARCH_OS	?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_ARCH_CPU	?= $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)

source		:= $(shell dpkg-parsechangelog | grep ^Source: | sed -e 's/^.*: //g')
full_version	:= $(shell dpkg-parsechangelog | grep ^Version: | sed -e 's/^.*: //g')
tar_version	:= $(shell echo $(full_version) | sed -e 's/-.*//g')
svn_revision	:= $(shell echo $(full_version) | sed -e 's/.*~svn\([0-9]*\)-[0-9]*/\1/g' -e 's/^$(full_version)$$/HEAD/g')
version		:= $(shell echo $(full_version) | sed -e 's/[~+-].*//g')
major           := $(shell echo $(version) | sed -e 's/\..*//g')
revision	:= $(shell echo $(full_version) | sed -e 's/^[^+-]*//g')
cpu		:= $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
config_files	:= $(wildcard debian/arch/$(cpu)/*.config)
flavours	:= $(config_files:debian/arch/$(cpu)/%.config=%)
configfile	:= DEBCUSTOM
abiname		:= 0
ld_target	:= $(shell ld --help | sed -ne "s/[^ :]*: supported targets: \([^ ]*\) .*/\1/p")

ifeq ($(cpu), mipsel)
kfreebsd_cpu	:= mips
else
kfreebsd_cpu	:= $(cpu)
endif

#SVN		:= https://svn0.us-west.freebsd.org/base/release/$(version).0
SVN		:= https://svn0.us-west.freebsd.org/base/releng/$(version)
#SVN		:= https://svn0.us-west.freebsd.org/base/stable/$(major)
#SVN		:= https://svn0.us-west.freebsd.org/base/head
SOURCE_PACKAGE	:= $(CURDIR)/debian/kfreebsd-source-$(version)
IMAGE_PACKAGE	:= $(CURDIR)/debian/kfreebsd-image-$(version)-$(abiname)
HEADERS_PACKAGE	:= $(CURDIR)/debian/kfreebsd-headers-$(version)-$(abiname)
SRC_TAR		:= kfreebsd-source-$(version).tar.xz
SRC_DIR		:= kfreebsd-source-$(version)
HEADERS_DIR	:= kfreebsd-headers-$(version)-$(abiname)
FLAVOR_DIR	:= flavor-$(version)-$(abiname)
ORIG_DIR	:= $(source)-$(tar_version)
ORIG_TAR	:= $(source)_$(tar_version).orig.tar.xz
PATH		:= /usr/lib/freebsd:$(PATH)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))

	# Do not mess with MAKEFLAGS until we transfer control to BSD make (see below)
	BSD_MAKEFLAGS += -j$(NUMJOBS)
endif

MAKE		:= \
		MAKEFLAGS=$(BSD_MAKEFLAGS) \
		make \
		MACHINE_ARCH=$(kfreebsd_cpu) \
		-DWITHOUT_SOURCELESS

# Clang is the default compiler on these architectures (see src/share/mk/bsd.own.mk)
clang_cpus	:= i386 amd64 arm

cc_pkg		:= clang-3.4 (>= 1:3.4.2-9~exp2) [$(foreach cpu,$(clang_cpus),any-$(cpu))], \
		gcc-4.9 [$(foreach cpu,$(clang_cpus),!any-$(cpu))]

ifneq (, $(filter $(clang_cpus), $(DEB_HOST_ARCH_CPU)))
cc_cmd		:= clang-3.4
else
cc_cmd		:= gcc-4.9
endif

ifeq ($(cc_cmd), clang)
MAKE	+= -DWITH_CLANG_IS_CC
else
MAKE	+= -DWITHOUT_CLANG_IS_CC
MAKE	+= WERROR=
endif

MAKE += -DWITHOUT_CTF

# Disable install of *.ko.symbols files (their presence would trigger an
# "unstripped-binary-or-object" lintian error).
MAKE += -DWITHOUT_KERNEL_SYMBOLS	

# Disable ssp for now ...
# at least under QEMU it panics, might be due to
#   - QEMU
#   - newer gcc compared to plain FreeBSD
#   - different init order
#   - ...
MAKE += -DWITHOUT_SSP

get-orig-source:
	rm -rf $(ORIG_DIR)
	svn export --ignore-keywords -r $(svn_revision) $(SVN)/sys $(ORIG_DIR)/sys
	cd $(ORIG_DIR) && $(CURDIR)/debian/prune.sh
	tar --numeric-owner --owner 0 --group 0 -cJf ../$(ORIG_TAR) $(ORIG_DIR)
	rm -rf $(ORIG_DIR)

control: clean
	for arch in `ls $(CURDIR)/debian/arch/` ; do \
		KW_CONFIG_DIR=debian/installer/$$arch ; \
		if test -e $$KW_CONFIG_DIR ; then \
			for config in `ls $(CURDIR)/debian/arch/$$arch/ | grep \.config` ; do \
				flavor=$${config/.config/} ; \
				if test -e debian/arch/$$arch/$$flavor.installer ; then \
					echo "kfreebsd-$$arch $(version)-$(abiname) $$flavor $(version)-$(abiname)-$$flavor - -" ; \
				fi ; \
			done > $$KW_CONFIG_DIR/kernel-versions ; \
		fi ; \
		echo ; \
	done
	sed -e "s/@major@/$(major)/g" -e "s/@version@/$(version)/g" -e "s/@abiname@/$(abiname)/g" -e "s/@flavor@/$$flavor/g" \
		-e "s/@cc_pkg@/$(cc_pkg)/g" \
		$(CURDIR)/debian/control.in > $(CURDIR)/debian/control
	echo >> $(CURDIR)/debian/control
	for arch in `ls $(CURDIR)/debian/arch/` ; do \
		for config in `ls $(CURDIR)/debian/arch/$$arch/ | grep \.config` ; do \
			flavor=$${config/.config/} ; \
			recommends= ; \
			test -f $(CURDIR)/debian/arch/$$arch/$$flavor.defines && recommends=`awk '/^Recommends: / {print $$2}' $(CURDIR)/debian/arch/$$arch/$$flavor.defines` ; \
			sed -e "s/@major@/$(major)/g" -e "s/@version@/$(version)/g" -e "s/@abiname@/$(abiname)/g" -e "s/@flavor@/$$flavor/g" -e "s/@arch@/$$arch/g" -e "s/@recommends@/$$recommends/g" \
				$(CURDIR)/debian/control.flavor.in ; \
			echo ; \
		done ; \
		export KW_DEFCONFIG_DIR=debian/installer ; \
		export KW_CONFIG_DIR=debian/installer/$$arch ; \
		if test -e $$KW_CONFIG_DIR/kernel-versions ; then \
			kernel-wedge gen-control ; \
		fi ; \
		echo ; \
	done >> $(CURDIR)/debian/control

clean:
	dh_testdir
	dh_testroot
	rm -rf kfreebsd-source-* flavor-*
	rm -f debian/kfreebsd-image-*.preinst
	rm -f debian/kfreebsd-image-*.prerm
	rm -f debian/kfreebsd-image-*.postinst
	rm -f debian/kfreebsd-image-*.postrm

	rm -f *-stamp
	dh_clean

build-indep: build-indep-stamp
build-indep-stamp:
	dh_testdir

	mkdir -p $(SRC_DIR)
	cp -af sys $(SRC_DIR)/

	touch build-indep-stamp

build: build-arch build-indep

install-indep: install-indep-stamp
install-indep-stamp: build-indep
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs -i

	mkdir -p $(SOURCE_PACKAGE)/usr/src
	chown -R root.src $(SRC_DIR)
	# Avoid the top-level directory timestamp changing
	touch $(SRC_DIR) --reference=$(SRC_DIR)/sys
	tar cfJ $(SOURCE_PACKAGE)/usr/src/$(SRC_TAR) $(SRC_DIR)

	touch install-indep-stamp

build-arch: $(foreach flavor,$(flavours),build-flavor-$(flavor)-stamp)
src-flavor-%-stamp:
	mkdir -p $(FLAVOR_DIR)-$*
	cp -af sys $(FLAVOR_DIR)-$*/

	# Compile objects with relative, not absolute paths, to avoid embedding
	# full build tree paths into modules (Bug #757629)
	find $(FLAVOR_DIR)-$*/sys/modules/ \
	 \( -name Makefile -o -name Makefile.inc \) \
	 -exec sed -i 's@$${.CURDIR}/@@g' \{\} \;

	touch $@
build-flavor-%-stamp: src-flavor-%-stamp
	# Add the abiname and the flavor to the kernel version
	sed -i -e 's/^RELEASE=".*"/RELEASE="$(version)-$(abiname)-$*"/g' $(FLAVOR_DIR)-$*/sys/conf/newvers.sh

	# Change ident to the kernel version
	sed -i -e 's/^i=.*/i="Debian $* ($(full_version))"/g' $(FLAVOR_DIR)-$*/sys/conf/newvers.sh

	# Set /lib/modules/${RELEASE} as module dir
	sed -i -e 's,^KODIR?=.*,KODIR="/lib/modules/$(version)-$(abiname)-$*",g' $(FLAVOR_DIR)-$*/sys/conf/kern.pre.mk

	# Always set explicit link target to match with ld's implicit target (needed
	# to build on non-kFreeBSD)
	sed -i \
		-e 's/elf32-i386-freebsd/$(ld_target)/g' \
		-e 's/elf64-x86-64-freebsd/$(ld_target)/g' \
		-e 's/elf32-tradlittlemips-freebsd/$(ld_target)/g' \
		-e 's/elf32-tradbigmips-freebsd/$(ld_target)/g' \
	$(FLAVOR_DIR)-$*/sys/conf/ldscript.$(kfreebsd_cpu)

	# Configure the kernel
	cp debian/arch/$(cpu)/$*.config $(FLAVOR_DIR)-$*/sys/$(kfreebsd_cpu)/conf/
	ln -sf $*.config $(FLAVOR_DIR)-$*/sys/$(kfreebsd_cpu)/conf/$(configfile)
	cd $(FLAVOR_DIR)-$*/sys/$(kfreebsd_cpu)/conf \
		&& config $(configfile)

	# We must rebuild firmware from sources, per the DFSG
	CFLAGS='-D_GNU_SOURCE -isystem /usr/include/freebsd' LDFLAGS='-ldb -lbsd' \
	 $(MAKE) CC=$(cc_cmd) -C $(FLAVOR_DIR)-$*/sys/modules/aic7xxx/ firmware

	# Build it
	$(MAKE) CC=$(cc_cmd) -C $(FLAVOR_DIR)-$*/sys/$(kfreebsd_cpu)/compile/$(configfile)/ depend
	$(MAKE) CC=$(cc_cmd) -C $(FLAVOR_DIR)-$*/sys/$(kfreebsd_cpu)/compile/$(configfile)/

	touch build-flavor-$*-stamp

install-common-stamp:
	dh_testdir
	dh_testroot
	mkdir -p $(HEADERS_PACKAGE)/usr/src/$(HEADERS_DIR)
